diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityCow.java b/src/main/java/net/minecraft/core/entity/animal/CowMob.java
similarity index 68%
rename from src/main/java/net/minecraft/core/entity/animal/EntityCow.java
rename to src/main/java/net/minecraft/core/entity/animal/CowMob.java
index 4878e4d23..8b4c863ed 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityCow.java
+++ b/src/main/java/net/minecraft/core/entity/animal/CowMob.java
@@ -2,27 +2,27 @@ package net.minecraft.core.entity.animal;
 
 
 // Referenced classes of package net.minecraft.src:
-//            EntityAnimal, Item, EntityPlayer, InventoryPlayer, 
+//            Animal, Item, Player, InventoryPlayer,
 //            ItemStack, World, NBTTagCompound
 
 import net.minecraft.core.WeightedRandomLootObject;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.item.Item;
-import net.minecraft.core.item.ItemBucketEmpty;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.Items;
+import net.minecraft.core.item.EmptyBucketItem;
 import net.minecraft.core.item.ItemStack;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
 
-public class EntityCow extends EntityAnimal
+public class CowMob extends Animal
 {
 
-    public EntityCow(World world)
+    public CowMob(World world)
     {
         super(world);
         textureIdentifier = new NamespaceID("minecraft", "cow");
         setSize(0.9F, 1.3F);
-        mobDrops.add(new WeightedRandomLootObject(Item.leather.getDefaultStack(), 1, 5));
+        mobDrops.add(new WeightedRandomLootObject(Items.LEATHER.getDefaultStack(), 1, 5));
     }
 
     @Override
@@ -62,12 +62,12 @@ public class EntityCow extends EntityAnimal
     }
 
     @Override
-	public boolean interact(EntityPlayer entityplayer)
+	public boolean interact(Player entityplayer)
     {
         ItemStack itemstack = entityplayer.inventory.getCurrentItem();
-        if(itemstack != null && itemstack.itemID == Item.bucket.id)
+        if(itemstack != null && itemstack.itemID == Items.BUCKET.id)
         {
-            ItemBucketEmpty.useBucket(entityplayer, new ItemStack(Item.bucketMilk));
+            EmptyBucketItem.useBucket(entityplayer, new ItemStack(Items.BUCKET_MILK));
             return true;
         }
         return super.interact(entityplayer);
diff --git a/src/main/java/net/minecraft/core/entity/animal/IAnimal.java b/src/main/java/net/minecraft/core/entity/animal/Creature.java
similarity index 64%
rename from src/main/java/net/minecraft/core/entity/animal/IAnimal.java
rename to src/main/java/net/minecraft/core/entity/animal/Creature.java
index c8ab92122..db8402ed2 100644
--- a/src/main/java/net/minecraft/core/entity/animal/IAnimal.java
+++ b/src/main/java/net/minecraft/core/entity/animal/Creature.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.entity.animal;
 
 
-public interface IAnimal
+public interface Creature
 {
 }
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityFireflyCluster.java b/src/main/java/net/minecraft/core/entity/animal/FireflyClusterMob.java
similarity index 89%
rename from src/main/java/net/minecraft/core/entity/animal/EntityFireflyCluster.java
rename to src/main/java/net/minecraft/core/entity/animal/FireflyClusterMob.java
index 434fda998..657bebcb7 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityFireflyCluster.java
+++ b/src/main/java/net/minecraft/core/entity/animal/FireflyClusterMob.java
@@ -4,7 +4,7 @@ import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityFlying;
+import net.minecraft.core.entity.FlyingMob;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.DamageType;
 import net.minecraft.core.util.helper.MathHelper;
@@ -17,9 +17,12 @@ import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
 
-public class EntityFireflyCluster extends EntityFlying
-        implements IAnimal
+public class FireflyClusterMob extends FlyingMob
+        implements Creature
 {
+	public static final int DATA_COLOR_ID = 16;
+	public static final int DATA_CLUSTER_SIZE_ID = 17;
+	public static final int DATA_COUNT_ID = 18;
 	public final int maxLifetime = 12000;
 	public final int maxClusterSize = 6;
     public final int slowUpdateCooldownMax = 500;
@@ -36,7 +39,7 @@ public class EntityFireflyCluster extends EntityFlying
     private int slowUpdateCooldown;
     
     
-    public EntityFireflyCluster(World world)
+    public FireflyClusterMob(World world)
     {
         super(world);
         if(world == null || world.isClientSide) {
@@ -60,7 +63,7 @@ public class EntityFireflyCluster extends EntityFlying
 
 	@Override
 	public void spawnInit() {
-		super.init();
+		super.defineSynchedData();
 		Biome currentBiome = world.getBlockBiome((int) x, (int) y, (int) z);
 		FireflyColor color = null;
 
@@ -135,42 +138,39 @@ public class EntityFireflyCluster extends EntityFlying
     }
 
     @Override
-    protected void init()
+    protected void defineSynchedData()
     {
-        super.init();
-
-		// Color
-		entityData.define(16, (byte) 0);
-		// Cluster Size
-		entityData.define(17, (byte) 0);
-		// Firefly Count
-		entityData.define(18, (byte) 0);
+        super.defineSynchedData();
+
+		entityData.define(DATA_COLOR_ID, (byte) 0);
+		entityData.define(DATA_CLUSTER_SIZE_ID, (byte) 0);
+		entityData.define(DATA_COUNT_ID, (byte) 0);
     }
 
 	public void setColor(FireflyColor colour) {
-		entityData.set(16, (byte) colour.getId());
+		entityData.set(DATA_COLOR_ID, (byte) colour.getId());
 	}
 
 	public FireflyColor getColor() {
-		int id = entityData.getByte(16);
+		int id = entityData.getByte(DATA_COLOR_ID);
 		return FireflyColor.fireFlyColors.get(id);
 	}
 	
 	public void setClusterSize(int clusterSize) {
-		entityData.set(17, (byte) clusterSize);
+		entityData.set(DATA_CLUSTER_SIZE_ID, (byte) clusterSize);
 		setSizeBasedOnClusterSize(clusterSize);
 	}
 	
 	public int getClusterSize() {
-		return entityData.getByte(17) & 0xFF;
+		return entityData.getByte(DATA_CLUSTER_SIZE_ID) & 0xFF;
 	}
 	
 	public void setFireflyCount(int fireflyCount) {
-		entityData.set(18, (byte) fireflyCount);
+		entityData.set(DATA_COUNT_ID, (byte) fireflyCount);
 	}
 	
 	public int getFireflyCount() {
-		return entityData.getByte(18) & 0xFF;
+		return entityData.getByte(DATA_COUNT_ID) & 0xFF;
 	}
     
 //    private boolean isCourseTraversable(double waypointX, double waypointY, double waypointZ, double distanceFromEntity)
@@ -193,7 +193,7 @@ public class EntityFireflyCluster extends EntityFlying
 //    }
 
     @Override
-    protected void updatePlayerActionState()
+    protected void updateAI()
     {
         //After 5 minutes, firefly changes color to match biome
         
@@ -226,11 +226,11 @@ public class EntityFireflyCluster extends EntityFlying
     }
 
     @Override
-    public boolean getCanSpawnHere()
+    public boolean canSpawnHere()
     {
-        int x = MathHelper.floor_double(this.x);
-        int y = MathHelper.floor_double(bb.minY);
-        int z = MathHelper.floor_double(this.z);
+        int x = MathHelper.floor(this.x);
+        int y = MathHelper.floor(bb.minY);
+        int z = MathHelper.floor(this.z);
         int id = world.getBlockId(x, y - 1, z);
 
 		if (shouldRemove()) return false;
@@ -242,7 +242,7 @@ public class EntityFireflyCluster extends EntityFlying
         if(world.getCurrentWeather() != null && world.getCurrentWeather().doMobsSpawnInDaylight)
             blockLight = blockLight/2;
 
-        return  blockLight <= 4 && (Block.blocksList[id] != null && Block.blocksList[id].hasTag(BlockTags.FIREFLIES_CAN_SPAWN)) && world.checkIfAABBIsClear(bb.expand(-2f, 0f, -2f));
+        return  blockLight <= 4 && (Block.blocksList[id] != null && Block.blocksList[id].hasTag(BlockTags.FIREFLIES_CAN_SPAWN)) && world.checkIfAABBIsClear(bb.grow(-2f, 0f, -2f));
     }
 
     @Override
@@ -347,9 +347,9 @@ public class EntityFireflyCluster extends EntityFlying
 			expandIfPossible();
 		}
 		
-		int blockX = MathHelper.floor_double(x);
-		int blockY = MathHelper.floor_double(y);
-		int blockZ = MathHelper.floor_double(z);
+		int blockX = MathHelper.floor(x);
+		int blockY = MathHelper.floor(y);
+		int blockZ = MathHelper.floor(z);
 		FireflyColor colorForBiome = getColourForBiome(world.getBlockBiome(blockX, blockY, blockZ));
 		if(colorForBiome != this.getColor()) {
 			setColor(colorForBiome);
@@ -359,7 +359,7 @@ public class EntityFireflyCluster extends EntityFlying
 	private void merge() {
 		slowUpdateCooldown = slowUpdateCooldownMax;
 		
-		List<Entity> nearbyFireflies = world.getEntitiesWithinAABB(getClass(), bb.expand(2, 2, 2));
+		List<Entity> nearbyFireflies = world.getEntitiesWithinAABB(getClass(), bb.grow(2, 2, 2));
 		int nearbyCount = nearbyFireflies.size();
 		
 		if(nearbyCount == 1) {
@@ -369,10 +369,10 @@ public class EntityFireflyCluster extends EntityFlying
 		
 		for(int i=0; i < nearbyCount; i++) {
 			Entity entity = nearbyFireflies.get(i);
-			if(entity == this || !(entity instanceof EntityFireflyCluster)) {
+			if(entity == this || !(entity instanceof FireflyClusterMob)) {
 				continue;
 			}
-			EntityFireflyCluster fireflyCluster = (EntityFireflyCluster) entity;
+			FireflyClusterMob fireflyCluster = (FireflyClusterMob) entity;
 			if(fireflyCluster.getColor() != this.getColor()) {
 				continue;
 			}
@@ -390,7 +390,7 @@ public class EntityFireflyCluster extends EntityFlying
 		}
 	}
 	
-	private void merge(EntityFireflyCluster from, EntityFireflyCluster to) {
+	private void merge(FireflyClusterMob from, FireflyClusterMob to) {
 		if(from.getFireflyCount() + to.getFireflyCount() < maxFireflyCountPerCluster) {
 			to.setFireflyCount(to.getFireflyCount() + from.getFireflyCount());
 			from.remove();
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntityPig.java b/src/main/java/net/minecraft/core/entity/animal/PigMob.java
similarity index 57%
rename from src/main/java/net/minecraft/core/entity/animal/EntityPig.java
rename to src/main/java/net/minecraft/core/entity/animal/PigMob.java
index 068acdc77..6dd14e84a 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntityPig.java
+++ b/src/main/java/net/minecraft/core/entity/animal/PigMob.java
@@ -2,16 +2,16 @@ package net.minecraft.core.entity.animal;
 
 
 // Referenced classes of package net.minecraft.src:
-//            EntityAnimal, DataWatcher, NBTTagCompound, World, 
-//            EntityPlayer, Item, EntityPigZombie, AchievementList, 
-//            EntityLightningBolt
+//            Animal, DataWatcher, NBTTagCompound, World,
+//            Player, Item, ZombiePigMob, Achievements,
+//            LightningEntity
 
 import net.minecraft.core.WeightedRandomLootObject;
-import net.minecraft.core.achievement.AchievementList;
-import net.minecraft.core.entity.EntityLightningBolt;
-import net.minecraft.core.entity.monster.EntityPigZombie;
-import net.minecraft.core.entity.player.EntityPlayer;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.achievement.Achievements;
+import net.minecraft.core.entity.LightningEntity;
+import net.minecraft.core.entity.monster.ZombiePigMob;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.item.Items;
 import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.world.World;
@@ -19,22 +19,22 @@ import net.minecraft.core.world.World;
 import java.util.ArrayList;
 import java.util.List;
 
-public class EntityPig extends EntityAnimal
+public class PigMob extends Animal
 {
+    public static final int DATA_SADDLE_ID = 16;
 
-    public EntityPig(World world)
+    public PigMob(World world)
     {
         super(world);
         textureIdentifier = new NamespaceID("minecraft", "pig");
         setSize(0.9F, 0.9F);
-        mobDrops.add(new WeightedRandomLootObject(Item.foodPorkchopRaw.getDefaultStack(), 1, 2));
-        burningMobDrops.add(new WeightedRandomLootObject(Item.foodPorkchopCooked.getDefaultStack(), 1, 2));
+        mobDrops.add(new WeightedRandomLootObject(Items.FOOD_PORKCHOP_RAW.getDefaultStack(), 1, 2));
+        burningMobDrops.add(new WeightedRandomLootObject(Items.FOOD_PORKCHOP_COOKED.getDefaultStack(), 1, 2));
     }
 
     @Override
-	protected void init()
-    {
-        entityData.define(16, Byte.valueOf((byte)0));
+	protected void defineSynchedData() {
+        entityData.define(DATA_SADDLE_ID, Byte.valueOf((byte)0));
     }
 
     @Override
@@ -70,7 +70,7 @@ public class EntityPig extends EntityAnimal
     }
 
     @Override
-	public boolean interact(EntityPlayer entityplayer)
+	public boolean interact(Player entityplayer)
     {
         if (super.interact(entityplayer)) return true;
         if (getSaddled() && !world.isClientSide && (passenger == null || passenger == entityplayer))
@@ -85,12 +85,12 @@ public class EntityPig extends EntityAnimal
     }
 
     @Override
-	protected void dropFewItems()
+	protected void dropDeathItems()
     {
         if(getSaddled()){
-            spawnAtLocation(Item.saddle.id, 1);
+            spawnAtLocation(Items.SADDLE.id, 1);
         }
-        super.dropFewItems();
+        super.dropDeathItems();
     }
 
     @Override
@@ -107,43 +107,36 @@ public class EntityPig extends EntityAnimal
 
     public boolean getSaddled()
     {
-        return (entityData.getByte(16) & 1) != 0;
+        return (entityData.getByte(DATA_SADDLE_ID) & 1) != 0;
     }
 
     public void setSaddled(boolean flag)
     {
         if(flag)
         {
-            entityData.set(16, Byte.valueOf((byte)1));
+            entityData.set(DATA_SADDLE_ID, Byte.valueOf((byte)1));
         } else
         {
-            entityData.set(16, Byte.valueOf((byte)0));
+            entityData.set(DATA_SADDLE_ID, Byte.valueOf((byte)0));
         }
     }
 
     @Override
-	public void thunderHit(EntityLightningBolt bolt)
+	public void thunderHit(LightningEntity bolt)
     {
-        if(world.isClientSide)
-        {
-            return;
-        } else
-        {
-            EntityPigZombie entitypigzombie = new EntityPigZombie(world);
+        if (!world.isClientSide) {
+            ZombiePigMob entitypigzombie = new ZombiePigMob(world);
             entitypigzombie.moveTo(x, y, z, yRot, xRot);
             world.entityJoinedWorld(entitypigzombie);
             remove();
-            return;
         }
     }
 
     @Override
-	protected void causeFallDamage(float f)
-    {
-        super.causeFallDamage(f);
-        if(f > 5F && (passenger instanceof EntityPlayer))
-        {
-            ((EntityPlayer) passenger).triggerAchievement(AchievementList.FLY_PIG);
+	protected void causeFallDamage(float distance) {
+        super.causeFallDamage(distance);
+        if(distance > 5F && (passenger instanceof Player)) {
+            ((Player) passenger).triggerAchievement(Achievements.FLY_PIG);
         }
     }
     public List<WeightedRandomLootObject> burningMobDrops = new ArrayList<>();
diff --git a/src/main/java/net/minecraft/core/entity/animal/EntitySheep.java b/src/main/java/net/minecraft/core/entity/animal/SheepMob.java
similarity index 56%
rename from src/main/java/net/minecraft/core/entity/animal/EntitySheep.java
rename to src/main/java/net/minecraft/core/entity/animal/SheepMob.java
index 797bdabb8..4055780ce 100644
--- a/src/main/java/net/minecraft/core/entity/animal/EntitySheep.java
+++ b/src/main/java/net/minecraft/core/entity/animal/SheepMob.java
@@ -1,29 +1,28 @@
 package net.minecraft.core.entity.animal;
 
+import com.mojang.nbt.CompoundTag;
 import net.minecraft.core.block.Block;
-import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.EntityItem;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.block.Blocks;
+import net.minecraft.core.entity.ItemEntity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
-import com.mojang.nbt.CompoundTag;
-import net.minecraft.core.item.ItemToolShears;
+import net.minecraft.core.item.ToolShearsItem;
 import net.minecraft.core.util.collection.NamespaceID;
-import net.minecraft.core.world.World;
-import net.minecraft.core.util.helper.DamageType;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
 
 import java.util.Random;
 
-// Referenced classes of package net.minecraft.src:
-//            EntityAnimal, DataWatcher, ItemStack, Block, 
-//            EntityPlayer, InventoryPlayer, Item, ItemShears, 
-//            World, EntityItem, NBTTagCompound, Entity
-
-public class EntitySheep extends EntityAnimal
+public class SheepMob extends Animal
 {
+    public static final int DATA_WOOL_STATE_ID = 16;
+    public static final int MASK_WOOL_COLOR = 0b0000_1111;
+    public static final int MASK_SHEARED = 0b0001_0000;
+    public static final int DATA_EATING_ID = 17;
 
-    public EntitySheep(World world)
+    public SheepMob(World world)
     {
         super(world);
         textureIdentifier = new NamespaceID("minecraft", "sheep");
@@ -31,48 +30,40 @@ public class EntitySheep extends EntityAnimal
     }
 
     @Override
-    protected void init()
+    protected void defineSynchedData()
     {
-        super.init();
-        entityData.define(16, (byte) 0);
-        entityData.define(17, (byte) 0);
+        super.defineSynchedData();
+        entityData.define(DATA_WOOL_STATE_ID, (byte) 0);
+        entityData.define(DATA_EATING_ID, (byte) 0);
     }
 
     @Override
     public void spawnInit()
     {
-        super.init();
         setFleeceColor(getRandomFleeceColor(random));
     }
-
-    @Override
-    public boolean hurt(Entity attacker, int i, DamageType type)
-    {
-        return super.hurt(attacker, i, type);
-    }
-
     @Override
-    protected void dropFewItems()
+    protected void dropDeathItems()
     {
-        super.dropFewItems();
+        super.dropDeathItems();
         if(!getSheared())
         {
-            spawnAtLocation(new ItemStack(Block.wool.id, 1, getFleeceColor()), 0.0F);
+            spawnAtLocation(new ItemStack(Blocks.WOOL.id, 1, getFleeceColor().blockMeta), 0.0F);
         }
     }
     @Override
-    public boolean interact(EntityPlayer entityplayer)
+    public boolean interact(Player entityplayer)
     {
         if (super.interact(entityplayer)) return true;
         ItemStack itemstack = entityplayer.inventory.getCurrentItem();
         if(itemstack != null)
         {
-            if (itemstack.getItem() instanceof ItemToolShears && !getSheared()){
+            if (itemstack.getItem() instanceof ToolShearsItem && !getSheared()){
                 if(!world.isClientSide) {
                     setSheared(true);
                     int count = 2 + random.nextInt(3);
                     for (int j = 0; j < count; j++) {
-                        EntityItem entityitem = spawnAtLocation(new ItemStack(Block.wool.id, 1, getFleeceColor()), 1.0F);
+                        ItemEntity entityitem = spawnAtLocation(new ItemStack(Blocks.WOOL.id, 1, getFleeceColor().blockMeta), 1.0F);
                         entityitem.yd += random.nextFloat() * 0.05F;
                         entityitem.xd += (random.nextFloat() - random.nextFloat()) * 0.1F;
                         entityitem.zd += (random.nextFloat() - random.nextFloat()) * 0.1F;
@@ -93,7 +84,7 @@ public class EntitySheep extends EntityAnimal
     {
         super.addAdditionalSaveData(tag);
         tag.putBoolean("Sheared", getSheared());
-        tag.putByte("Color", (byte)getFleeceColor());
+        tag.putByte("Color", (byte)getFleeceColor().blockMeta);
         tag.putShort("GrowthTimer", (short) growthTimer);
     }
 
@@ -102,7 +93,7 @@ public class EntitySheep extends EntityAnimal
     {
         super.readAdditionalSaveData(tag);
         setSheared(tag.getBoolean("Sheared"));
-        setFleeceColor(tag.getByte("Color"));
+        setFleeceColor(DyeColor.colorFromBlockMeta(tag.getByte("Color")));
         setGrowthTimer(tag.getShort("GrowthTimer"));
     }
 
@@ -114,12 +105,12 @@ public class EntitySheep extends EntityAnimal
 
     public boolean getIsSheepEating()
     {
-        return entityData.getByte(17) != 0;
+        return entityData.getByte(DATA_EATING_ID) != 0;
     }
 
     protected void setIsSheepEating(boolean value)
     {
-        entityData.set(17, (byte)(value ? 1 : 0));
+        entityData.set(DATA_EATING_ID, (byte)(value ? 1 : 0));
     }
 
     @Override
@@ -132,13 +123,13 @@ public class EntitySheep extends EntityAnimal
 
 		
 		if (growthTimer > 400) {
-			int blockX = MathHelper.floor_double(x);
-			int blockY = MathHelper.floor_double(y);
-			int blockZ = MathHelper.floor_double(z);
+			int blockX = MathHelper.floor(x);
+			int blockY = MathHelper.floor(y);
+			int blockZ = MathHelper.floor(z);
 			Block blockBelow = world.getBlock(blockX, blockY - 1, blockZ);
 			
 			growthTimer = 0;
-			if (blockBelow == Block.grass || blockBelow == Block.grassRetro) {
+			if (blockBelow == Blocks.GRASS || blockBelow == Blocks.GRASS_RETRO) {
 				if(!world.isClientSide) {
 					setIsSheepEating(true);
 				}
@@ -149,22 +140,22 @@ public class EntitySheep extends EntityAnimal
 		}
 
 		if (getIsSheepEating()) {
-			int blockX = MathHelper.floor_double(x);
-			int blockY = MathHelper.floor_double(y);
-			int blockZ = MathHelper.floor_double(z);
+			int blockX = MathHelper.floor(x);
+			int blockY = MathHelper.floor(y);
+			int blockZ = MathHelper.floor(z);
 			Block blockBelow = world.getBlock(blockX, blockY - 1, blockZ);
 			
 			if (timeSheepEating >= 5 && timeSheepEating <= 35 && timeSheepEating % 5 == 0 && !world.isClientSide) {
-				world.playBlockSoundEffect(null, x + 0.5, y + 0.5, z + 0.5, Block.grass, EnumBlockSoundEffectType.DIG);
+				world.playBlockSoundEffect(null, x + 0.5, y + 0.5, z + 0.5, Blocks.GRASS, EnumBlockSoundEffectType.DIG);
 			}
 			
 			prevTimeSheepEating = timeSheepEating;
 			timeSheepEating++;
 			if (prevTimeSheepEating == 35) {
-				if(blockBelow == Block.grass || blockBelow == Block.grassRetro) {
+				if(blockBelow == Blocks.GRASS || blockBelow == Blocks.GRASS_RETRO) {
 					if(!world.isClientSide) {
 						world.playSoundEffect(null, 2001, (int) x, (int) y - 1, (int) z, world.getBlockId((int) x, (int) y - 1, (int) z));
-						world.setBlockWithNotify(blockX, blockY - 1, blockZ, Block.dirt.id);
+						world.setBlockWithNotify(blockX, blockY - 1, blockZ, Blocks.DIRT.id);
 						setSheared(false);
 					}
 				}
@@ -198,90 +189,73 @@ public class EntitySheep extends EntityAnimal
         return "mob.sheep";
     }
 
-    public int getFleeceColor()
+    public DyeColor getFleeceColor()
     {
-        return entityData.getByte(16) & 0xf;
+        return DyeColor.colorFromBlockMeta(entityData.getByte(DATA_WOOL_STATE_ID) & MASK_WOOL_COLOR);
     }
 
-    public void setFleeceColor(int i)
+    public void setFleeceColor(DyeColor color)
     {
-        byte byte0 = entityData.getByte(16);
-        entityData.set(16, Byte.valueOf((byte)(byte0 & 0xf0 | i & 0xf)));
+        byte woolState = entityData.getByte(DATA_WOOL_STATE_ID);
+        entityData.set(16, (byte) (woolState & ~MASK_WOOL_COLOR | color.blockMeta & MASK_WOOL_COLOR));
     }
 
     public boolean getSheared()
     {
-        return (entityData.getByte(16) & 0x10) != 0;
+        return (entityData.getByte(DATA_WOOL_STATE_ID) & MASK_SHEARED) != 0;
     }
 
     public void setSheared(boolean flag)
     {
-        byte byte0 = entityData.getByte(16);
+        byte woolState = entityData.getByte(DATA_WOOL_STATE_ID);
         if(flag)
         {
-            entityData.set(16, (byte) (byte0 | 0x10));
+            entityData.set(DATA_WOOL_STATE_ID, (byte) (woolState | MASK_SHEARED));
         } else
         {
-            entityData.set(16, (byte) (byte0 & 0xffffffef));
+            entityData.set(DATA_WOOL_STATE_ID, (byte) (woolState & ~MASK_SHEARED));
         }
     }
 
-    public static int getRandomFleeceColor(Random random)
+    public static DyeColor getRandomFleeceColor(Random random)
     {
         int i = random.nextInt(100);
         if(i < 5)
         {
-            return 15;
+            return DyeColor.BLACK;
         }
         if(i < 10)
         {
-            return 7;
+            return DyeColor.GRAY;
         }
         if(i < 15)
         {
-            return 8;
+            return DyeColor.SILVER;
         }
         if(i < 18)
         {
-            return 12;
+            return DyeColor.BROWN;
         }
-        return random.nextInt(500) != 0 ? 0 : 6;
+        return random.nextInt(500) != 0 ? DyeColor.WHITE : DyeColor.PINK;
     }
 
-    public static final float[][] fleeceColorTable = {
-        {
-            1.0F, 1.0F, 1.0F
-        }, {
-            0.95F, 0.7F, 0.2F
-        }, {
-            0.9F, 0.5F, 0.85F
-        }, {
-            0.6F, 0.7F, 0.95F
-        }, {
-            0.9F, 0.9F, 0.2F
-        }, {
-            0.5F, 0.8F, 0.1F
-        }, {
-            0.95F, 0.7F, 0.8F
-        }, {
-            0.3F, 0.3F, 0.3F
-        }, {
-            0.6F, 0.6F, 0.6F
-        }, {
-            0.3F, 0.6F, 0.7F
-        }, {
-            0.7F, 0.4F, 0.9F
-        }, {
-            0.2F, 0.4F, 0.8F
-        }, {
-            0.5F, 0.4F, 0.3F
-        }, {
-            0.4F, 0.5F, 0.2F
-        }, {
-            0.8F, 0.3F, 0.3F
-        }, {
-            0.1F, 0.1F, 0.1F
-        }
+    public static final float[][] FLEECE_COLOR_TABLE = {
+        {  1.0F,  1.0F,  1.0F  }, // White
+        {  0.95F, 0.7F,  0.2F  }, // Orange
+        {  0.9F,  0.5F,  0.85F }, // Magenta
+        {  0.6F,  0.7F,  0.95F }, // Light Blue
+        {  0.9F,  0.9F,  0.2F  }, // Yellow
+        {  0.5F,  0.8F,  0.1F  }, // Lime
+        {  0.95F, 0.7F,  0.8F  }, // Pink
+        {  0.3F,  0.3F,  0.3F  }, // Grey
+        {  0.6F,  0.6F,  0.6F  }, // Silver
+        {  0.3F,  0.6F,  0.7F  }, // Cyan
+        {  0.7F,  0.4F,  0.9F  }, // Purple
+        {  0.2F,  0.4F,  0.8F  }, // Blue
+        {  0.5F,  0.4F,  0.3F  }, // Brown
+        {  0.4F,  0.5F,  0.2F  }, // Green
+        {  0.8F,  0.3F,  0.3F  }, // Red
+        {  0.1F,  0.1F,  0.1F  }  // Black
     };
 
     public void setGrowthTimer(int growthTimer){
